From a8520d417fa25e19fc2427213c18295ee835d1e4 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 25 2020 19:14:19 +0000
Subject: [PATCH 192/2232] Merge pull request #83 from myronahn/feature/result-quick-fix


Make Result work with UniquePtr, RustBox, RustString, Str
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index e11b2d3..69b7fb5 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -225,10 +225,24 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
             #local_name(#(#vars),*)
         }
     };
-    let expr = efn
-        .ret
-        .as_ref()
-        .and_then(|ret| match ret {
+    let expr = if efn.throws {
+        efn.ret.as_ref().and_then(|ret| match ret {
+            Type::Ident(ident) if ident == RustString => {
+                Some(quote!(#call.map(|r| r.into_string())))
+            }
+            Type::RustBox(_) => Some(quote!(#call.map(|r| ::std::boxed::Box::from_raw(r)))),
+            Type::UniquePtr(_) => Some(quote!(#call.map(|r| ::cxx::UniquePtr::from_raw(r)))),
+            Type::Ref(ty) => match &ty.inner {
+                Type::Ident(ident) if ident == RustString => {
+                    Some(quote!(#call.map(|r| r.as_string())))
+                }
+                _ => None,
+            },
+            Type::Str(_) => Some(quote!(#call.map(|r| r.as_str()))),
+            _ => None,
+        })
+    } else {
+        efn.ret.as_ref().and_then(|ret| match ret {
             Type::Ident(ident) if ident == RustString => Some(quote!(#call.into_string())),
             Type::RustBox(_) => Some(quote!(::std::boxed::Box::from_raw(#call))),
             Type::UniquePtr(_) => Some(quote!(::cxx::UniquePtr::from_raw(#call))),
@@ -239,7 +253,8 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
             Type::Str(_) => Some(quote!(#call.as_str())),
             _ => None,
         })
-        .unwrap_or(call);
+    }
+    .unwrap_or(call);
     quote! {
         #doc
         pub fn #ident(#(#args),*) #ret {
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index bd9d4df..5d0598e 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -36,6 +36,8 @@ pub mod ffi {
         fn c_try_return_void() -> Result<()>;
         fn c_try_return_primitive() -> Result<usize>;
         fn c_fail_return_primitive() -> Result<usize>;
+        fn c_try_return_string() -> Result<UniquePtr<CxxString>>;
+        fn c_fail_return_string() -> Result<UniquePtr<CxxString>>;
     }
 
     extern "Rust" {
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 184e8aa..90538b9 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -98,6 +98,14 @@ size_t c_try_return_primitive() { return 2020; }
 
 size_t c_fail_return_primitive() { throw std::logic_error("logic error"); }
 
+std::unique_ptr<std::string> c_try_return_string() {
+  return std::unique_ptr<std::string>(new std::string("ok"));
+}
+
+std::unique_ptr<std::string> c_fail_return_string() { 
+  throw std::logic_error("logic error getting string"); 
+}
+
 extern "C" C *cxx_test_suite_get_unique_ptr() noexcept {
   return std::unique_ptr<C>(new C{2020}).release();
 }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 6a5f802..7f45287 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -39,5 +39,7 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
 void c_try_return_void();
 size_t c_try_return_primitive();
 size_t c_fail_return_primitive();
+std::unique_ptr<std::string> c_try_return_string();
+std::unique_ptr<std::string> c_fail_return_string();
 
 } // namespace tests
diff --git a/tests/test.rs b/tests/test.rs
index d86ebd2..9f1ea24 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -45,6 +45,18 @@ fn test_c_return() {
         "logic error",
         ffi::c_fail_return_primitive().unwrap_err().what(),
     );
+    assert_eq!(
+        "ok",
+        ffi::c_try_return_string()
+            .unwrap()
+            .as_ref()
+            .unwrap()
+            .to_string()
+    );
+    assert_eq!(
+        "logic error getting string",
+        ffi::c_fail_return_string().unwrap_err().what(),
+    );
 }
 
 #[test]

